import 'package:blue_thermal_printer/blue_thermal_printer.dart';
import 'package:dio/dio.dart';

class TestPrint {
  BlueThermalPrinter bluetooth = BlueThermalPrinter.instance;

  sample() async {
    bluetooth.isConnected.then((isConnected) async {
      if (isConnected) {
        // for (var i = 0; i < 5; i++) {
        List<int> data = [];
        var barcode =
            await bluetooth.getBarCode("02345678901234567890", 300, 120, 0);

        data.addAll(PrintData.initPrinter());
        data.addAll(PrintData.printText("采样编码", size: 3, bold: true, space: 1));
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printText("VIP添加样", size: 2));
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printText("硫/量热仪/灰分"));
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printMarginLeft(11));
        data.addAll(PrintData.printQRCode("02345678901234567890"));
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printMarginLeft(5));
        data.addAll(barcode);
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printText("马上来货运"));
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        data.addAll(PrintData.printNewLine());
        bluetooth.writeBytes(Uint8List.fromList(data));
        await Future.delayed(Duration(milliseconds: 500));
        // }
      }
    });
  }

  sample1() async {
    bluetooth.isConnected.then((isConnected) async {
      if (isConnected) {
        Map<String, dynamic> config = Map();
        config['width'] = 100; // 标签宽度，单位mm
        config['height'] = 150; // 标签高度，单位mm
        config['gap'] = 2; // 标签间隔，单位mm

        List<Map<String, dynamic>> data = [];
        //ByteData imageByte = await rootBundle.load("assets/images/WechatIMG91.png");
        // List<int> imageBytes = imageByte.buffer.asUint8List(imageByte.offsetInBytes, imageByte.lengthInBytes);
        // String base64Image = base64Encode(imageBytes);

        // 下载远程图片，转换为字节流
        var str = "https://img1.baidu.com/it/u=873106765,2587410047&fm=253&fmt=auto&app=138&f=JPEG?w=530&h=500";
        Response<List<int>> rs = await Dio().get<List<int>>(
          str,
          options: Options(
            responseType: ResponseType.bytes,
          ),
        );
        String base64Image = base64Encode(rs.data);

        //打印配置
        Map<String, dynamic> image = Map();
        image['type'] = 'image';
        image['x'] = 0;
        image['y'] = 0;
        image['width'] = 800;
        image['content'] = base64Image;
        data.add(image);
        bluetooth.printTSCImage(config, data);
        await Future.delayed(Duration(milliseconds: 500));
      }
    });
  }
}
